<!--产品正反面颜色-->
<template>
  <div class="app-container">
    <el-row :gutter="10" class="mb8" v-if="optType !='view'">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['mes:md:faceColor:add']"
        >新增</el-button>
        <ColorSelect ref="colorSelect" @onSelected="onColorSelected" > </ColorSelect>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['mes:md:faceColor:remove']"
        >删除</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="faceColorList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="排序号" align="center" prop="sortOrder" />
      <el-table-column label="颜色编码" align="center" prop="colorCode">
        <template slot-scope="scope">
          <el-color-picker :value="scope.row.colorCode"></el-color-picker>
        </template>
      </el-table-column>
      <el-table-column label="颜色名称" align="center" prop="colorName" />
      <el-table-column label="覆盖率(单位%)" align="center" prop="coverageRate" :show-overflow-tooltip="true" />
<!--      <el-table-column label="创建人" align="center" prop="createBy" />
      <el-table-column label="创建时间" align="center" prop="createTime" />
      <el-table-column label="修改人" align="center" prop="updateBy" />
      <el-table-column label="修改时间" align="center" prop="updateTime" />-->
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width" v-if="optType !='view'">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['mes:md:faceColor:edit']"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['mes:md:faceColor:remove']"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改产品颜色关系对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="600px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="120px">
        <el-form-item label="排序号" prop="sortOrder">
          <el-input v-model="form.sortOrder" type="number" placeholder="请输入排序号" />
        </el-form-item>
        <el-form-item label="颜色编码" prop="colorCode">
          <el-input v-model="form.colorCode" readonly placeholder="请输入颜色" />
        </el-form-item>
        <el-form-item label="颜色名称" prop="colorName">
          <el-input v-model="form.colorName" readonly placeholder="请输入颜色" />
        </el-form-item>
        <el-form-item label="覆盖率(单位%)" prop="coverageRate">
          <el-input v-model="form.coverageRate"  type="textarea" placeholder="请输入覆盖率" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>

  </div>
</template>

<script>
import { listFaceColor, getFaceColor, delFaceColor, addFaceColor, updateFaceColor } from "@/api/mes/md/faceColor";
import ColorSelect  from "@/components/colorSelect/index.vue";
//import faceColor from "@/views/mes/md/product/components/faceColor.vue";

export default {
  name: "FaceColor",
  components: { ColorSelect },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 产品BOM关系表格数据
      faceColorList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        itemId: this.itemId,
        colorId: null,
        mdFaceColorId: null,
        colorName: null,
        colorCode: null,
        face: 'front',
        coverageRate: null,
        sortOrder: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        /*quantity: [
          { required: true, message: "物料使用比例不能为空", trigger: "blur" }
        ]*/
      }
    };
  },
  props: {
    optType: undefined,
    itemId: undefined
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询产品颜色关系列表 */
    getList() {
      this.loading = true;
      listFaceColor(this.queryParams).then(response => {
        this.faceColorList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        itemId: null,
        colorId: null,
        mdFaceColorId: null,
        colorName: null,
        colorCode: null,
        coverageRate: null,
        sortOrder: null,
        face: "front",
        createBy: null,
        createTime: null,
        updateBy: null,
        updateTime: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.mdFaceColorId)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.$refs.colorSelect.showFlag = true;
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const mdFaceColorId = row.mdFaceColorId || this.ids
      getFaceColor(mdFaceColorId).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改产品颜色";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          updateFaceColor(this.form).then(response => {
            this.$modal.msgSuccess("修改成功");
            this.open = false;
            this.getList();
          });
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const mdFaceColorIds = row.mdFaceColorId || this.ids;
      this.$modal.confirm('是否确认删除产品BOM关系编号为"' + mdFaceColorIds + '"的数据项？').then(function() {
        return delFaceColor(mdFaceColorIds);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {});
    },
    //物料选择弹出框
    onColorSelected(obj){
      this.form.itemId = this.itemId;
      if(obj != undefined && obj != null){
        obj.forEach(element => {
          //this.form.itemId = element.itemId;
          this.form.colorId = element.colorId;
          this.form.colorName = element.colorName;
          this.form.colorCode = element.colorCode;
          this.form.face = 'front';
          var retFlag = false;
          const idx = this.faceColorList.findIndex(itm => itm.colorId == element.colorId)
          if (idx > -1) {
            this.$modal.msgError("新增颜色失败，颜色已存在");
            return
          }
          addFaceColor(this.form).then(response => {
            this.$modal.msgSuccess("新增成功");
            this.getList();
          });
        });
      }
    }
  }
};
</script>
